import { EVMAccountAddress, EVMContractAddress, TokenUri, TokenId, CrumbsContractError, HexString } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { ICrumbsContract } from "../interfaces/ICrumbsContract";
import { ContractOverrides } from "../interfaces/objects/ContractOverrides";
export declare class CrumbsContract implements ICrumbsContract {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    contractAddress: EVMContractAddress;
    protected contract: ethers.Contract;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, contractAddress: EVMContractAddress);
    addressToCrumbId(accountAddress: EVMAccountAddress): ResultAsync<TokenId | null, CrumbsContractError>;
    tokenURI(tokenId: TokenId): ResultAsync<TokenUri | null, CrumbsContractError>;
    createCrumb(crumbId: TokenId, tokenUri: TokenUri, contractOverrides?: ContractOverrides): ResultAsync<void, CrumbsContractError>;
    encodeCreateCrumb(crumbId: TokenId, crumbContent: TokenUri): HexString;
    burnCrumb(crumbId: TokenId, contractOverrides?: ContractOverrides | undefined): ResultAsync<void, CrumbsContractError>;
    encodeBurnCrumb(crumbId: TokenId): HexString;
    updateTokenURI(crumbId: TokenId, tokenURI: TokenUri): ResultAsync<void, CrumbsContractError>;
    getContract(): ethers.Contract;
}
//# sourceMappingURL=CrumbsContract.d.ts.map