import { EVMAccountAddress, EVMContractAddress, MinimalForwarderContractError, BigNumberString, Signature } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { IMinimalForwarderContract, IMinimalForwarderRequest } from "../interfaces";
export declare class MinimalForwarderContract implements IMinimalForwarderContract {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    protected contract: ethers.Contract;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, contractAddress: EVMContractAddress);
    getNonce(from: EVMAccountAddress): ResultAsync<BigNumberString, MinimalForwarderContractError>;
    verify(request: IMinimalForwarderRequest, signature: Signature): ResultAsync<boolean, MinimalForwarderContractError>;
    execute(request: IMinimalForwarderRequest, signature: Signature): ResultAsync<ethers.providers.TransactionResponse, MinimalForwarderContractError>;
    getContract(): ethers.Contract;
}
//# sourceMappingURL=MinimalForwarderContract.d.ts.map