import { EVMContractAddress, BaseURI, RewardsFactoryError, ECreatedRewardType } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { ContractOverrides, IRewardsContractFactory } from "../interfaces/index.js";
export declare class RewardsContractFactory implements IRewardsContractFactory {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    protected rewardType: ECreatedRewardType;
    protected contractFactory: ethers.ContractFactory;
    protected rewardTypeToDeploy: ECreatedRewardType;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, rewardType: ECreatedRewardType);
    deployERC721Reward(name: string, symbol: string, baseURI: BaseURI, overrides?: ContractOverrides | null): ResultAsync<EVMContractAddress, RewardsFactoryError>;
    estimateGasToDeployERC721Contract(name: string, symbol: string, baseURI: BaseURI): ResultAsync<ethers.BigNumber, RewardsFactoryError>;
}
//# sourceMappingURL=RewardsContractFactory.d.ts.map