import { EVMContractAddress, TokenUri, SiftContractError, BaseURI, DomainName } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { ISiftContract } from "../interfaces/ISiftContract";
export declare class SiftContract implements ISiftContract {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    contractAddress: EVMContractAddress;
    protected contract: ethers.Contract;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, contractAddress: EVMContractAddress);
    checkURL(domain: DomainName): ResultAsync<TokenUri, SiftContractError>;
    verifyURL(domain: DomainName): ResultAsync<void, SiftContractError>;
    maliciousURL(domain: DomainName): ResultAsync<void, SiftContractError>;
    setBaseURI(baseUri: BaseURI): ResultAsync<void, SiftContractError>;
    getContract(): ethers.Contract;
}
//# sourceMappingURL=SiftContract.d.ts.map