"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WrappedTransactionResponse = void 0;
const objects_1 = require("@snickerdoodlelabs/objects");
const neverthrow_1 = require("neverthrow");
class WrappedTransactionResponse {
    constructor(txResponse) {
        this.txResponse = txResponse;
    }
    wait() {
        return neverthrow_1.ResultAsync.fromPromise(this.txResponse.wait(), (e) => {
            return new objects_1.TransactionResponseError("Unable to call wait() for transaction response.", e.reason);
        });
    }
}
exports.WrappedTransactionResponse = WrappedTransactionResponse;
//# sourceMappingURL=WrappedTransactionResponse.js.map